unit MainFrm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, MRVMediaSource, MRVCamera, Vcl.StdCtrls,
  MRVCamView;

type
  TForm16 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    RVCamView1: TRVCamView;
    Label1: TLabel;
    RVCamera1: TRVCamera;
    procedure Button1Click(Sender: TObject);
    procedure RVCamera1EndVideoStream(Sender: TObject; Status: Integer);
    procedure RVCamera1VideoStart(Sender: TObject);
    procedure RVCamera1StartVideoStream(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form16: TForm16;

implementation

{$R *.dfm}

procedure TForm16.Button1Click(Sender: TObject);
begin
  Label1.Caption := 'Stopping...';
  Label1.Update;
  RVCamera1.Abort;
  RVCamera1.WaitForVideo;
  if Trim(Edit1.Text) = '' then
  begin
    Beep;
    exit;
  end;
  Label1.Caption := 'Connecting';
  RVCamera1.URL := Edit1.Text;
  RVCamera1.PlayVideoStream;
end;

procedure TForm16.FormCreate(Sender: TObject);
begin
  if not RVCamera1.IsSupportedFFMPEG then
    Application.MessageBox('FFmpeg is not found (required for H.264 and RTSP)', 'FFmpeg', 0);
end;

procedure TForm16.RVCamera1EndVideoStream(Sender: TObject; Status: Integer);
begin
  if Status = 0 then
    Label1.Caption := 'Finished'
  else
    Label1.Caption := 'Error'
end;

procedure TForm16.RVCamera1StartVideoStream(Sender: TObject);
begin
  Label1.Caption := 'Playing';
end;

procedure TForm16.RVCamera1VideoStart(Sender: TObject);
begin
  Label1.Caption := 'Preparing to receive video';
end;

end.
